/*
fluxy. A Realtime 2d Path Tracer
---
Copyright (C) 2008  Sebastian Mach (*1983)
seb@greenhybrid.net | http://greenhybrid.net
---
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef COLORFRGB_H
#define COLORFRGB_H


class ColorFRGB
{
    private:
        float r,g,b;
    public:
        ColorFRGB() : r(0), g(0), b(0) {} ;
        ColorFRGB( float r, float g, float b ) : r(r), g(g), b(b) {} ;
        ~ColorFRGB() {};
        void to_rgb( float &r, float &g, float &b ) const {
            r = this->r;
            g = this->g;
            b = this->b;
        }
        ColorFRGB operator * ( float f ) const{
            return ColorFRGB( r*f, g*f, b*f );
        }
        ColorFRGB operator + ( const ColorFRGB &col ) const {
            return ColorFRGB( r+col.r, g+col.g, b+col.b );
        }
        ColorFRGB &operator += ( const ColorFRGB &col ) {
            r += col.r;
            g += col.g;
            b += col.b;
            return *this;
        }
};

#endif // COLORFRGB_H
