#ifndef SURFACE_H
#define SURFACE_H


template <class T> class Surface
{
    private:
        unsigned int width, height;
        T *m_surface;
    public:
        typedef T pixel_t;

        Surface(unsigned int width, unsigned int height)
        : width(width), height(height) {
            m_surface = new T[width*height];
        }
        ~Surface(){
            delete [] m_surface;
        }
        const T operator () ( unsigned int x, unsigned int y ) const {
            return m_surface[y*width+x];
        }
        T& operator () ( unsigned int x, unsigned int y ) {
            return m_surface[y*width+x];
        }

        unsigned int getWidth() const {
            return width;
        }
        unsigned int getHeight() const {
            return height;
        }

        T* checkOut() {
            return m_surface;
        }

        void checkIn() {
        }
};

#endif // SURFACE_H
